<?php
/**
 * BanLoginService.php
 * @author yzozhong.cen
 * @date 2012-7-25 22-06-13
 */
require_once ('ctrl/Opcodes.php');
require_once ('ctrl/ErrorCodes.php');
require_once ('libs/BaseServerAccesser.php');
require_once ('libs/mysql.config.inc.php');
class BanLoginService
{

	/**
	 * @brief 封禁用户
	 */
	public static function banLogin($begTime, $endTime, $roleId, $reason, $author, &$retcode, &$retmsg)
	{
		
		global $DB;
		
		if(empty($roleId))
		{
			$retcode = RET_CODE_COMMON_PARAM_ERR;
			$retmsg = '未指定角色';
			return array('retcode'=>$retcode,'retmsg'=>$retmsg);
		}
		
		if(empty($endTime))
		{
			$retcode = RET_CODE_COMMON_PARAM_ERR;
			$retmsg = '结束时间为空';
			return array('retcode'=>$retcode,'retmsg'=>$retmsg);
		}

		//踢人下线
		$arr_roleId = explode(',', $roleId);
		foreach($arr_roleId as $tmp_roleId)
		{
			$act = array(
					'op'     => OP_BAN_LOGIN,
					'roleId'  => trim($tmp_roleId),
					'endTime' => $endTime,
					);
			$tmp_retcode = 0;
			$tmp_retmsg = '';
			$result = BaseServerAccesser::sendToBase($act, $tmp_retcode, $tmp_retmsg); 
			if ($result['retcode'] != 0)
			{
				return array('retcode'=>$result['retcode'],'retmsg'=>"封号失败,角色ID:".$tmp_roleId);
			}
		}
	
		//组织sql
		/*
		$update_sql = "UPDATE `tbl_player_character` SET `is_ban`=1, `ban_expire`='$endTime', `updated`=NOW() WHERE `id` IN ($roleId)";
		
		global $DB;
		$result = $DB->query($update_sql);
		if($DB->geterrno() > 0)
		{
			$retcode = 1;
			$retmsg = $DB->geterrdesc();
			return array('retcode'=>$retcode,'retmsg'=>$retmsg);
		}
		*/
		
		$affect_num = substr_count($roleId, ',') + 1;
		$param['begTime'] = $begTime;
		$param['endTime'] = $endTime;
		$param['roleId']  = $roleId;
		$param['reason']  = $reason;
		$param['author']  = $author;
		$param = json_encode($param);
		$log_sql = "INSERT INTO `tbl_gmt_operation` (`func_name`, `author`, `reason`, `beg_time`, `end_time`, `affect_cids`, `affect_num`, `param`)
				VALUES('GameTools.banLogin', '$author', '$reason', '$begTime', '$endTime', '$roleId', $affect_num, '$param')";
		
		$result = $DB->query($log_sql);
		if($DB->geterrno() > 0)
		{
			$retcode = 1;
			$retmsg = $DB->geterrdesc();
			return array('retcode'=>$retcode,'retmsg'=>$retmsg);
		}
		return array('retcode'=>0,'retmsg'=>"操作成功");
		
	}
	
	/**
	 * 解封账号
	 * @param unknown_type $roleId
	 * @param unknown_type $reason
	 * @param unknown_type $author
	 * @param unknown_type $retcode
	 * @param unknown_type $retmsg
	 */
	public static function unBanLogin($roleId, $reason, $author, &$retcode, &$retmsg)
	{
		global $DB;
		
		if(empty($roleId))
		{
			$retcode = RET_CODE_COMMON_PARAM_ERR;
			$retmsg = '未指定角色';
			return array('retcode'=>$retcode,'retmsg'=>$retmsg);
		}
				
		//组合sql语句
		/*
		$update_sql = "UPDATE `tbl_player_character` SET `is_ban`=0, `ban_expire`=NULL, `updated`=NOW() WHERE `id` IN ($roleId)";
		global $DB;
		$DB->query($update_sql);
		if($DB->geterrno() > 0)
		{
			$retcode = 1;
			$retmsg = $DB->geterrdesc();
			return array('retcode'=>$retcode,'retmsg'=>$retmsg);
		}
		*/
		
		//解封账号
		$arr_roleId = explode(',', $roleId);
		foreach($arr_roleId as $tmp_roleId)
		{
			$act = array(
					'op'     => OP_UNBAN_LOGIN,
					'roleId'  => $tmp_roleId,
			);
			
			$result = BaseServerAccesser::sendToBase($act, $tmp_retcode, $tmp_retmsg);
			if ($result['retcode'] != 0)
			{
				return array('retcode'=>$result['retcode'],'retmsg'=>"解封账号失败,角色ID:".$tmp_roleId);
			}
		}
		
		$affect_num = substr_count($roleId, ',') + 1;
		$param['roleId'] = $roleId;
		$param['reason'] = $reason;
		$param['author'] = $author;
		$param = json_encode($param);
				
		$log_sql = "INSERT INTO `tbl_gmt_operation` (`func_name`, `author`, `reason`, `affect_cids`, `affect_num`, `param`)
				VALUES('GameTools.unBanLogin', '$author', '$reason', '$roleId', $affect_num, '$param')";
		
		$DB->query($log_sql);
		if($DB->geterrno() > 0)
		{
			$retcode = 1;
			$retmsg = $DB->geterrdesc();
			return array('retcode'=>$retcode,'retmsg'=>$retmsg);
		}
		return array('retcode'=>0,'retmsg'=>"操作成功");
		//TODO 解封用户
	}

	/**
	 * @brief 获取封禁列表
	 * @return string data
	 */
	public static function getBanLoginlist($begTime, $endTime, $opType, $opValue, $page, $pagecount,&$retcode, &$retmsg)
	{
		//$where = " `func_name`='GameTools.banLogin'";
		$where = " `is_ban` = 1";

		//查询类型
		if(!empty($opType) and !empty($opValue))
		{
			switch($opType)
			{
			case 1:				//passportID
				if(intval($opValue) <= 0)
				{
					$retcode = RET_CODE_COMMON_PARAM_ERR;
					$retmsg = 'passportID不是数字';
					return array('retcode'=>$retcode,'retmsg'=>$retmsg);
				}
				$where .= " AND `player_id`=$opValue";
				break;
			case 2:				//通行证
				$where .= " AND `account`=$opValue";
				break;
			case 3:				//角色id
				if(intval($opValue) <= 0)
				{
					$retcode = RET_CODE_COMMON_PARAM_ERR;
					$retmsg = '角色id不是数字';
					return array('retcode'=>$retcode,'retmsg'=>$retmsg);
				}
				$where .= " AND `id`=$opValue";
				break;
			case 4:				//角色名
				$where .= " AND `nick` like '%$opValue%'";
				break;
			default:
				$retcode = RET_CODE_USER_OPTYPE_ERR;
				$retmsg = 'opType错误';
				return array('retcode'=>$retcode,'retmsg'=>$retmsg);
			}
		}
		
		if($begTime && $endTime && $begTime > $endTime)
		{
			$retcode = RET_CODE_COMMON_PARAM_ERR;
			$retmsg = '开始时间不能大于结束时间';
			return array('retcode'=>$retcode,'retmsg'=>$retmsg);
		}
		
		//开始时间
		if(!empty($begTime))
		{
			$where .= " AND `ban_expire`>='$begTime'";
		}
		//结束时间
		if(!empty($endTime))
		{
			$where .= " AND `ban_expire`<='$endTime'";
		}

		//分页
		if($page && $pagecount)
		{
			$beg_idx = ($page - 1) * $pagecount;
			$limit = " ORDER BY `id` LIMIT $beg_idx, $pagecount";
		}

		//组合sql语句
		//$sql = "SELECT `reason`, `affect_cids` AS `roleId`, `beg_time` AS `begTime`, `end_time` AS `endTime` FROM `tbl_gmt_operation` WHERE $where $limit";
		$sql = "SELECT `player_id` AS `passportId`, `nick` AS `roleName`, `id` AS `roleId`, `ban_expire` AS `endTime` FROM `tbl_player_character` WHERE $where $limit";
		
		global $DB;
		$result = $DB->query($sql);
		if($DB->geterrno() > 0)
		{
			$retcode = 1;
			$retmsg = $DB->geterrdesc();
			return array('retcode'=>$retcode,'retmsg'=>$retmsg);
		}
		$rows = array();
		$row_cnt = $DB->num_rows($result);
		for($i = 0; $i < $row_cnt; ++$i)
		{
			$row = $DB->fetch_array($result);
			$rows[] = $row;
		}
		$DB->free_result($DB->result);
		return array('retcode'=>0,'retmsg'=>$retmsg,'data'=>$rows);
		//return $rows;
	}
}

?>
