<?php
/**
 * BanTalkService.php
 * @author yzozhong.cen
 * @date 2012-7-25 22-06-13
 */
require_once ('ctrl/Opcodes.php');
require_once ('ctrl/ErrorCodes.php');
require_once ('libs/BaseServerAccesser.php');
require_once ('libs/mysql.config.inc.php');
class BanTalkService
{

	/**
	 * @brief 禁言用户
	 */
	public static function banTalk($startTime, $endTime, $reason, $author, $roleId, $ext, &$retcode, &$retmsg)
	{
		if(empty($roleId))
		{
			$retcode = RET_CODE_COMMON_PARAM_ERR;
			$retmsg = '角色Id为空';
			return array('retcode'=>$retcode,'retmsg'=>$retmsg);
		}
		if(empty($endTime))
		{
			$retcode = RET_CODE_COMMON_PARAM_ERR;
			$retmsg = '结束时间为空';
			return array('retcode'=>$retcode,'retmsg'=>$retmsg);
		}
		
		//封禁用户
		$act = array(
				'op' => OP_BAN_TALK,
				'startTime' => $startTime,
				'endTime' => $endTime,
				'reason' => $reason,
				'author' => $author,
				'roleId' => $roleId,
				'ext' => $ext,
				);
		//var_dump($act);
		$result = BaseServerAccesser::sendToBase($act, $retcode, $retmsg);
		return $result;
	}
	
	/**
	 * 解除禁言
	 */
	public static function unBanTalk($reason, $author, $roleId, $ext, &$retcode, &$retmsg)
	{
		if(empty($roleId))
		{
			$retcode = RET_CODE_COMMON_PARAM_ERR;
			$retmsg = '角色Id为空';
			return array('retcode'=>$retcode,'retmsg'=>$retmsg);
		}
	
		//解禁
		$act = array(
				'op' => OP_UNBAN_TALK,
				'startTime' => $startTime,
				'endTime' => $endTime,
				'reason' => $reason,
				'author' => $author,
				'roleId' => $roleId,
				'ext' => $ext,
				);
		$result = BaseServerAccesser::sendToBase($act, $retcode, $retmsg);
		return $result;
	}

	//TODO 修改以便于无参数时获取较佳的返回值
	/**
	 * @brief 获取被禁言的玩家列表
	 * @return string data
	 */
	public static function getBanTalkList($begTime, $endTime, $opType, $opValue, $page, $pagecount, &$retcode, &$retmsg)
	{
		//查询base中被禁言的用户
		$act = array(
				'op' => OP_GET_BAN_TALK,
				);
				
		$base_result = BaseServerAccesser::sendToBase($act, $retcode, $retmsg);
		
		if(!empty($base_result) and (is_array($base_result) or is_object($base_result)))
		{
			$ban_list = $base_result['data'];
			foreach($ban_list as $cid => &$ban_item)
			{
				$ban_item['roleId'] = $cid;
				$arr_cid[] = $cid;
			}
			
			if(!empty($arr_cid))
			{
				$where = '';
				if((!empty($opType) and !empty($opValue)))
				{
					//查询类型
					switch($opType)
					{
					case 1:				//passportID
						if(intval($opValue) <= 0)
						{
							$retcode = RET_CODE_COMMON_PARAM_ERR;
							$retmsg = 'passportID不是数字';
							return array('retcode'=>$retcode,'retmsg'=>$retmsg);
						}
						$where = " `player_id`=$opValue";
						break;
					case 2:				//通行证
						$retcode = RET_CODE_USER_OPTYPE_ERR;
						$retmsg = '不支持通行证名查询';
						return array('retcode'=>$retcode,'retmsg'=>$retmsg);
					case 3:				//角色id
						if(intval($opValue) <= 0)
						{
							$retcode = RET_CODE_COMMON_PARAM_ERR;
							$retmsg = '角色id不是数字';
							return array('retcode'=>$retcode,'retmsg'=>$retmsg);
						}
						$where = " `id`=$opValue";
						break;
					case 4:				//角色名
						$where = " `nick`='$opValue'";
						break;
					default:
						$retcode = RET_CODE_USER_OPTYPE_ERR;
						$retmsg = 'opType错误';
						return array('retcode'=>$retcode,'retmsg'=>$retmsg);
					}
				}

				$ids_str = implode($arr_cid);
				$where .= $where ? " AND `character_id` IN ($ids_str) " : " `character_id` IN ($ids_str) ";
				//分页
				if($page && $pagecount)
				{
					$beg_idx = ($page - 1) * $pagecount;
					$limit = " ORDER BY `id` LIMIT $beg_idx, $pagecount";
				}

				//组合sql语句
				$sql = "SELECT `character_id`, `nick`, `player_id` FROM `tbl_character_base` WHERE $where $limit";
				
				global $DB;
				$result = $DB->query($sql);
				if($DB->geterrno() == 0)
				{
					$row_cnt = $DB->num_rows($result);
					for($i = 0; $i < $row_cnt; ++$i)
					{
						$row = $DB->fetch_array($result);
						$cid = $row['character_id'];
						$ban_list[$cid]['roleName'] = $row['nick'];
						$ban_list[$cid]['passportId'] = $row['player_id'];
					}
					$DB->free_result($DB->result);
				}
			}
			
			return array('retcode'=>0,'retmsg'=>$retmsg,'data'=>$ban_list);
			
		}
		return array('retcode'=>0,'retmsg'=>"","data"=>array());
		
	}
}

?>
